From 1ac29ffde1e24d6740e854d2a9c1f24f9f71b036 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Wed, 30 Oct 2024 04:01:02 +0200
Subject: [PATCH 57/57] unit.rulesets: Update CollectRansom documentation

Barbarian Leader does not need to be 'lone', just 'undefended'

See RM #1039

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/alien/units.ruleset         | 2 +-
 data/civ1/units.ruleset          | 2 +-
 data/civ2/units.ruleset          | 2 +-
 data/civ2civ3/units.ruleset      | 2 +-
 data/classic/units.ruleset       | 2 +-
 data/goldkeep/units.ruleset      | 2 +-
 data/granularity/units.ruleset   | 2 +-
 data/multiplayer/units.ruleset   | 2 +-
 data/ruledit/comments-3.3.txt    | 2 +-
 data/sandbox/units.ruleset       | 2 +-
 data/stub/units.ruleset          | 2 +-
 data/webperimental/units.ruleset | 2 +-
 12 files changed, 12 insertions(+), 12 deletions(-)

diff --git a/data/alien/units.ruleset b/data/alien/units.ruleset
index 35e2e72ce2..67c9d11fe4 100644
--- a/data/alien/units.ruleset
+++ b/data/alien/units.ruleset
@@ -113,7 +113,7 @@ veteran_move_bonus = 0, 0, 0
 ;                       For class members which are transports, cargo cannot load/
 ;                       unload except in a city or native base, unless that unit
 ;                       explicitly lists this class in its 'embarks'/'disembarks'.
-; "CollectRansom"     = Unit can collect ransom when killing lone barbarian leader
+; "CollectRansom"     = Unit can collect ransom when killing undefended barbarian leader
 ; "ZOC"               = Unit is subject to ZOC rules. Unit type flag "IgZOC" can
 ;                       override this
 ; "DoesntOccupyTile"  = Even if this kind of enemy unit is on tile, cities can
diff --git a/data/civ1/units.ruleset b/data/civ1/units.ruleset
index 746cb459a9..b52abf63d0 100644
--- a/data/civ1/units.ruleset
+++ b/data/civ1/units.ruleset
@@ -110,7 +110,7 @@ veteran_move_bonus = 0, 0
 ;                       For class members which are transports, cargo cannot load/
 ;                       unload except in a city or native base, unless that unit
 ;                       explicitly lists this class in its 'embarks'/'disembarks'.
-; "CollectRansom"     = Unit can collect ransom when killing lone barbarian leader
+; "CollectRansom"     = Unit can collect ransom when killing undefended barbarian leader
 ; "ZOC"               = Unit is subject to ZOC rules. Unit type flag "IgZOC" can
 ;                       override this
 ; "DoesntOccupyTile"  = Even if this kind of enemy unit is on tile, cities can
diff --git a/data/civ2/units.ruleset b/data/civ2/units.ruleset
index 42971c5f17..e3cc92688c 100644
--- a/data/civ2/units.ruleset
+++ b/data/civ2/units.ruleset
@@ -118,7 +118,7 @@ veteran_move_bonus = 0, 0
 ;                       For class members which are transports, cargo cannot load/
 ;                       unload except in a city or native base, unless that unit
 ;                       explicitly lists this class in its 'embarks'/'disembarks'.
-; "CollectRansom"     = Unit can collect ransom when killing lone barbarian leader
+; "CollectRansom"     = Unit can collect ransom when killing undefended barbarian leader
 ; "ZOC"               = Unit is subject to ZOC rules. Unit type flag "IgZOC" can
 ;                       override this
 ; "DoesntOccupyTile"  = Even if this kind of enemy unit is on tile, cities can
diff --git a/data/civ2civ3/units.ruleset b/data/civ2civ3/units.ruleset
index cd45b05275..210d19c406 100644
--- a/data/civ2civ3/units.ruleset
+++ b/data/civ2civ3/units.ruleset
@@ -130,7 +130,7 @@ veteran_move_bonus = 0, 0, 0, 0
 ;                       For class members which are transports, cargo cannot load/
 ;                       unload except in a city or native base, unless that unit
 ;                       explicitly lists this class in its 'embarks'/'disembarks'.
-; "CollectRansom"     = Unit can collect ransom when killing lone barbarian leader
+; "CollectRansom"     = Unit can collect ransom when killing undefended barbarian leader
 ; "ZOC"               = Unit is subject to ZOC rules. Unit type flag "IgZOC" can
 ;                       override this
 ; "DoesntOccupyTile"  = Even if this kind of enemy unit is on tile, cities can
diff --git a/data/classic/units.ruleset b/data/classic/units.ruleset
index e072067dc9..16d3cfaac2 100644
--- a/data/classic/units.ruleset
+++ b/data/classic/units.ruleset
@@ -124,7 +124,7 @@ veteran_move_bonus = 0, 0, 0, 0
 ;                       For class members which are transports, cargo cannot load/
 ;                       unload except in a city or native base, unless that unit
 ;                       explicitly lists this class in its 'embarks'/'disembarks'.
-; "CollectRansom"     = Unit can collect ransom when killing lone barbarian leader
+; "CollectRansom"     = Unit can collect ransom when killing undefended barbarian leader
 ; "ZOC"               = Unit is subject to ZOC rules. Unit type flag "IgZOC" can
 ;                       override this
 ; "DoesntOccupyTile"  = Even if this kind of enemy unit is on tile, cities can
diff --git a/data/goldkeep/units.ruleset b/data/goldkeep/units.ruleset
index df2527c5ec..6becc4a548 100644
--- a/data/goldkeep/units.ruleset
+++ b/data/goldkeep/units.ruleset
@@ -128,7 +128,7 @@ veteran_move_bonus = 0, 0, 0, 0
 ;                       For class members which are transports, cargo cannot load/
 ;                       unload except in a city or native base, unless that unit
 ;                       explicitly lists this class in its 'embarks'/'disembarks'.
-; "CollectRansom"     = Unit can collect ransom when killing lone barbarian leader
+; "CollectRansom"     = Unit can collect ransom when killing undefended barbarian leader
 ; "ZOC"               = Unit is subject to ZOC rules. Unit type flag "IgZOC" can
 ;                       override this
 ; "DoesntOccupyTile"  = Even if this kind of enemy unit is on tile, cities can
diff --git a/data/granularity/units.ruleset b/data/granularity/units.ruleset
index 4f94b7a940..a9f711c6e3 100644
--- a/data/granularity/units.ruleset
+++ b/data/granularity/units.ruleset
@@ -110,7 +110,7 @@ veteran_move_bonus = 0, 0
 ;                       For class members which are transports, cargo cannot load/
 ;                       unload except in a city or native base, unless that unit
 ;                       explicitly lists this class in its 'embarks'/'disembarks'.
-; "CollectRansom"     = Unit can collect ransom when killing lone barbarian leader
+; "CollectRansom"     = Unit can collect ransom when killing undefended barbarian leader
 ; "ZOC"               = Unit is subject to ZOC rules. Unit type flag "IgZOC" can
 ;                       override this
 ; "DoesntOccupyTile"  = Even if this kind of enemy unit is on tile, cities can
diff --git a/data/multiplayer/units.ruleset b/data/multiplayer/units.ruleset
index 67ce1ab2b6..5be1b035ca 100644
--- a/data/multiplayer/units.ruleset
+++ b/data/multiplayer/units.ruleset
@@ -124,7 +124,7 @@ veteran_move_bonus = 0, 0, 0, 0
 ;                       For class members which are transports, cargo cannot load/
 ;                       unload except in a city or native base, unless that unit
 ;                       explicitly lists this class in its 'embarks'/'disembarks'.
-; "CollectRansom"     = Unit can collect ransom when killing lone barbarian leader
+; "CollectRansom"     = Unit can collect ransom when killing undefended barbarian leader
 ; "ZOC"               = Unit is subject to ZOC rules. Unit type flag "IgZOC" can
 ;                       override this
 ; "DoesntOccupyTile"  = Even if this kind of enemy unit is on tile, cities can
diff --git a/data/ruledit/comments-3.3.txt b/data/ruledit/comments-3.3.txt
index f86d52e717..ea5478a6b5 100644
--- a/data/ruledit/comments-3.3.txt
+++ b/data/ruledit/comments-3.3.txt
@@ -290,7 +290,7 @@ uclasses = "\
 ;                       For class members which are transports, cargo cannot load/\n\
 ;                       unload except in a city or native base, unless that unit\n\
 ;                       explicitly lists this class in its \'embarks\'/\'disembarks\'.\n\
-; \"CollectRansom\"     = Unit can collect ransom when killing lone barbarian leader\n\
+; \"CollectRansom\"     = Unit can collect ransom when killing undefended barbarian leader\n\
 ; \"ZOC\"               = Unit is subject to ZOC rules. Unit type flag \"IgZOC\" can\n\
 ;                       override this\n\
 ; \"DoesntOccupyTile\"  = Even if this kind of enemy unit is on tile, cities can\n\
diff --git a/data/sandbox/units.ruleset b/data/sandbox/units.ruleset
index 02efd987f6..d91273fb9c 100644
--- a/data/sandbox/units.ruleset
+++ b/data/sandbox/units.ruleset
@@ -140,7 +140,7 @@ veteran_move_bonus = 0, 0, 0, 0
 ;                       For class members which are transports, cargo cannot load/
 ;                       unload except in a city or native base, unless that unit
 ;                       explicitly lists this class in its 'embarks'/'disembarks'.
-; "CollectRansom"     = Unit can collect ransom when killing lone barbarian leader
+; "CollectRansom"     = Unit can collect ransom when killing undefended barbarian leader
 ; "ZOC"               = Unit is subject to ZOC rules. Unit type flag "IgZOC" can
 ;                       override this
 ; "DoesntOccupyTile"  = Even if this kind of enemy unit is on tile, cities can
diff --git a/data/stub/units.ruleset b/data/stub/units.ruleset
index c3d9e96021..d8dc881e98 100644
--- a/data/stub/units.ruleset
+++ b/data/stub/units.ruleset
@@ -89,7 +89,7 @@ veteran_move_bonus = 0
 ;                       For class members which are transports, cargo cannot load/
 ;                       unload except in a city or native base, unless that unit
 ;                       explicitly lists this class in its 'embarks'/'disembarks'.
-; "CollectRansom"     = Unit can collect ransom when killing lone barbarian leader
+; "CollectRansom"     = Unit can collect ransom when killing undefended barbarian leader
 ; "ZOC"               = Unit is subject to ZOC rules. Unit type flag "IgZOC" can
 ;                       override this
 ; "DoesntOccupyTile"  = Even if this kind of enemy unit is on tile, cities can
diff --git a/data/webperimental/units.ruleset b/data/webperimental/units.ruleset
index e6f177247d..69db190963 100644
--- a/data/webperimental/units.ruleset
+++ b/data/webperimental/units.ruleset
@@ -131,7 +131,7 @@ veteran_move_bonus = 0, 0, 0, 0
 ;                       For class members which are transports, cargo cannot load/
 ;                       unload except in a city or native base, unless that unit
 ;                       explicitly lists this class in its 'embarks'/'disembarks'.
-; "CollectRansom"     = Unit can collect ransom when killing lone barbarian leader
+; "CollectRansom"     = Unit can collect ransom when killing undefended barbarian leader
 ; "ZOC"               = Unit is subject to ZOC rules. Unit type flag "IgZOC" can
 ;                       override this
 ; "DoesntOccupyTile"  = Even if this kind of enemy unit is on tile, cities can
-- 
2.45.2