From 0b614212f4fbd5c1cab0b74e59be65663a168605 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Fri, 8 Nov 2024 18:32:08 +0200
Subject: [PATCH 56/56] Add action_decision_want icon animation

to supplied tilesets

See RM #1034

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/amplio/tiles.png          | Bin 76600 -> 87871 bytes
 data/amplio/tiles.spec         |   1 +
 data/amplio2/activities.png    | Bin 29180 -> 36008 bytes
 data/amplio2/activities.spec   |   1 +
 data/hex2t/items.png           | Bin 49375 -> 72792 bytes
 data/hex2t/items.spec          |   1 +
 data/hexemplio/activities.png  | Bin 22088 -> 11032 bytes
 data/hexemplio/activities.spec |   4 +++-
 8 files changed, 6 insertions(+), 1 deletion(-)

diff --git a/data/amplio/tiles.png b/data/amplio/tiles.png
index bc625399940357fd0147ca865bf114eea9eff15d..b5c12b28077d5a9ade130203a3f73bd5fb7e32d6 100644
GIT binary patch
diff --git a/data/amplio/tiles.spec b/data/amplio/tiles.spec
index 599b4277e9..15c33b2c3f 100644
--- a/data/amplio/tiles.spec
+++ b/data/amplio/tiles.spec
@@ -29,6 +29,7 @@ tiles = { "row", "column", "tag"
   0, 18, "unit.auto_attack",
          "unit.auto_worker"
   0, 19, "unit.stack"
+  0, 16, "unit.action_decision_want1"
   1, 16, "unit.action_decision_want0"
   1, 17, "unit.loaded"
   1, 18, "unit.connect"
diff --git a/data/amplio2/activities.png b/data/amplio2/activities.png
index d342cfddad7844f323f86e3707078e30f2cb8d4c..c7f5c064c1ddc1ba31d5a00309a066c6eef00704 100644
GIT binary patch
diff --git a/data/amplio2/activities.spec b/data/amplio2/activities.spec
index 22c00488d5..1d8cbb843a 100644
--- a/data/amplio2/activities.spec
+++ b/data/amplio2/activities.spec
@@ -55,6 +55,7 @@ tiles = { "row", "column", "tag"
   4, 1, "unit.convert"
   4, 2, "unit.auto_explore"
   4, 3, "unit.action_decision_want0"
+  4, 4, "unit.action_decision_want1"
 
 ; [GS]
   5,  0, "unit.irrigation"
diff --git a/data/hex2t/items.png b/data/hex2t/items.png
index 8e89605fc413ea40ad2059db41ab8e43353948db..a15c8022587fd20efbcd8d1893e5b4ec513ae7b4 100644
GIT binary patch
diff --git a/data/hex2t/items.spec b/data/hex2t/items.spec
index a059f6c03f..bfdd8a496c 100644
--- a/data/hex2t/items.spec
+++ b/data/hex2t/items.spec
@@ -212,6 +212,7 @@ tiles = { "row", "column", "tag"
 
 ; Unit activity letters:  (note unit icons have just "u.")
 
+  0, 11, "unit.action_decision_want1"
   0, 12, "unit.action_decision_want0"
   0, 13, "unit.convert"
   0, 14, "unit.auto_attack",
diff --git a/data/hexemplio/activities.png b/data/hexemplio/activities.png
index 6990b032afcb4d1089a545a9b5eabfb065a752ab..c0b68d27472dd68149d27896ff8065e7c0b6886c 100644
GIT binary patch
diff --git a/data/hexemplio/activities.spec b/data/hexemplio/activities.spec
index 3e1d35b7fc..7b12973ab3 100644
--- a/data/hexemplio/activities.spec
+++ b/data/hexemplio/activities.spec
@@ -35,7 +35,6 @@ tiles = { "row", "column", "tag"
   0, 4, "unit.goto"                     ;[?]
 ;  0, 5, "unit.patrol"                   ;[?]
   0, 6, "unit.convert"                  ;[?][GS]
-  0, 7, "unit.action_decision_want0"
 
 ; Unit activity letters: tile commands
 
@@ -72,4 +71,7 @@ tiles = { "row", "column", "tag"
   3,  3, "unit.oil_mine"                ;[GS]
   3,  4, "unit.oil_rig"                 ;[GS]
 
+  4,  0, "unit.action_decision_want0"
+  4,  1, "unit.action_decision_want1"
+
 }
-- 
2.45.2